#include "GameX.hpp"

#define PI	3.14159f
#define PI_2	1.570795f

class Body
{
private:
	ImageX boxImg;
	ImageX redImg;
	ImageX blueImg;
	ImageX bigRedImg;
	ImageX faceImg1;
	ImageX faceImg2;
	ImageX faceImg3;

	float elbow_phi, elbow_theta, wrist_phi, wrist_psi;
	
	Vector3DF fe1_pt[8];
	Vector3DF fe2_pt[8];
	Vector3DF sh1_pt[8];
	Vector3DF sh2_pt[8];
	Vector3DF th1_pt[8];
	Vector3DF th2_pt[8];
	Vector3DF pel_pt[8];
	Vector3DF tor_pt[8];
	Vector3DF sho_pt[8];
	Vector3DF nec_pt[8];
	Vector3DF hed_pt[8];

	Vector3DF upArm1_pt[8];
	Vector3DF upArm2_pt[8];
	Vector3DF loArm1_pt[8];
	Vector3DF loArm2_pt[8];
	Vector3DF hand1_pt[8];
	Vector3DF hand2_pt[8];

	Vector3DF orig_fe1_pt[8];
	Vector3DF orig_fe2_pt[8];
	Vector3DF orig_sh1_pt[8];
	Vector3DF orig_sh2_pt[8];
	Vector3DF orig_th1_pt[8];
	Vector3DF orig_th2_pt[8];
	Vector3DF orig_pel_pt[8];
	Vector3DF orig_tor_pt[8];
	Vector3DF orig_sho_pt[8];
	Vector3DF orig_nec_pt[8];
	Vector3DF orig_hed_pt[8];

	Vector3DF orig_upArm1_pt[8];
	Vector3DF orig_upArm2_pt[8];
	Vector3DF orig_loArm1_pt[8];
	Vector3DF orig_loArm2_pt[8];
	Vector3DF orig_hand1_pt[8];
	Vector3DF orig_hand2_pt[8];

	Vector3DF orig_loArm1_avg, orig_hand1_avg;
	Vector3DF tempPt;

	void DrawBoxPts(Vector3DF, Vector3DF, Vector3DF, Vector3DF, Vector3DF, Vector3DF, Vector3DF, Vector3DF);
	void DrawBoxPts(ImageX *img, Vector3DF pt[]);
	void DrawFace( Vector3DF pt[] );
	void DrawShirt( Vector3DF pt[] );

	void RotateAroundPoint(Vector3DF& position, Vector3DF vCenter, float angle, Vector3DF vAxis);
	void RotateAroundAxisX(Vector3DF &newPosition, Vector3DF vPoint, Vector3DF vCenter, float angle);
	void RotateAroundAxisY(Vector3DF &newPosition, Vector3DF vPoint, Vector3DF vCenter, float angle);

public:
	Body();
	void Draw();
	void RotateElbow(float phi, float theta);
	void RotateWrist(float phi, float psi);
	void Reset();
};


