#include "Console.hpp"
#include "gamex.hpp"

Console::Console(char* _logFileName, int _x1, int _y1, int _x2, int _y2)
{
	SetSize(_x1, _y1, _x2, _y2);
	showConsole = false;
	logFile = fopen(_logFileName, "w+");
	//hBufferMutex = CreateMutex( NULL, FALSE, "console buffer mutex" ); 
}

Console::~Console()
{
	fclose(logFile);
}

void Console::SetSize(int _x1, int _y1, int _x2, int _y2)
{
	string tempStr = "";

	//dwWaitResult = WaitForSingleObject(hBufferMutex, INFINITE);
	strBuffer.push_back(tempStr);
	//ReleaseMutex(hBufferMutex);

	x1 = _x1;
	y1 = _y1;
	x2 = _x2;
	y2 = _y2;
	locate_x = 0;
	locate_y = 0;
	maxLines = (y2-y1)/15;
	maxChars = (int)((float)(x2-x1)/7.7);
}

void Console::NewLine()
{
	//dwWaitResult = WaitForSingleObject(hBufferMutex, INFINITE);

	string tempStr = "";
	strBuffer.push_back(tempStr);

	if ((int) strBuffer.size() > maxLines)
		strBuffer.pop_front();

	//ReleaseMutex(hBufferMutex);
}

void Console::_Print(string newString)
{
	string stringRem = newString;
	int charsRem = (int) stringRem.size();
	//dwWaitResult = WaitForSingleObject(hBufferMutex, INFINITE);
	int curLineSpaces = maxChars - (int) (strBuffer.back().size());
	//ReleaseMutex(hBufferMutex);

	while ( charsRem > 0 )
	{
		if ( curLineSpaces >= charsRem )
		{
			//dwWaitResult = WaitForSingleObject(hBufferMutex, INFINITE);
			strBuffer.back() += stringRem;
			//ReleaseMutex(hBufferMutex);
			break;
		}
		else
		{
			//dwWaitResult = WaitForSingleObject(hBufferMutex, INFINITE);
			strBuffer.back() += stringRem.substr(0, curLineSpaces);
			//ReleaseMutex(hBufferMutex);
			stringRem = stringRem.substr(curLineSpaces+1, (int)stringRem.size());
			charsRem = (int) stringRem.size();

			curLineSpaces = maxChars;
			NewLine();
		}
	}
}

void Console::_Printf(string newString)
{
	int curPos = 0, delimPos = 0;
	int numChars = (int)newString.size();
	string addString = "";

	while(curPos < numChars)
	{
		delimPos = (int) newString.find("\n", curPos);
		if (delimPos == -1)
		{
			_Print(newString.substr(curPos, numChars-curPos));
			break;
		}
		else
		{
			string pString = newString.substr(curPos, delimPos-curPos);
			_Print(newString.substr(curPos, delimPos-curPos));
			curPos = delimPos + 1;
			NewLine();
		}
	}
}

void Console::Printf(LPCSTR lpszFormat, ...)
{
	try
	{
		va_list args;
		va_start(args, lpszFormat);
		
		int nBuf;
		char szBuffer[8024];
		
		nBuf = _vsnprintf(szBuffer, sizeof(szBuffer), lpszFormat, args);
		
		assert(nBuf < sizeof(szBuffer));  //Output truncated as it was > sizeof(szBuffer)
		
		_Printf(szBuffer);

		va_end(args);
	}
	catch(...)
	{
		assert(0);
	}
}

void Console::_Printfn(string newString)
{
	_Printf(newString);
	NewLine();
}

void Console::Printfn(LPCSTR lpszFormat, ...)
{
	try
	{
		va_list args;
		va_start(args, lpszFormat);
		
		int nBuf;
		char szBuffer[8024];
		
		nBuf = _vsnprintf(szBuffer, sizeof(szBuffer), lpszFormat, args);
		
		assert(nBuf < sizeof(szBuffer));  //Output truncated as it was > sizeof(szBuffer)

		fprintf(logFile, "%s\n", szBuffer);
		
		_Printf(szBuffer);

		va_end(args);
	}
	catch(...)
	{
		assert(0);
	}

	NewLine();
}

void Console::Draw()
{
	if (!showConsole)
		return;

	int i = 0;
	char *temp;
	LISTSTR::iterator ptr;

	// Draw Window
	GameX.SetDrawMode (DRAW_GHOST);
	GameX.DrawRect(ColorX(185,223,251), x1, y1, x2, y2);

	// Draw Text
	//dwWaitResult = WaitForSingleObject(hBufferMutex, INFINITE);
	for (ptr =  strBuffer.begin(); ptr != strBuffer.end(); ++ptr, i++)
	{
		temp = (char*)(ptr->c_str());
		GameX.DrawText( x1+10, y1+10+i*15, temp );
	}
	//ReleaseMutex(hBufferMutex);
}