#include "Elbow.hpp"


Elbow::Elbow()
{
}

Elbow::Elbow(Vector3DF _pos, int _dist, Point *_parent, CameraX *_cam) : Point (_pos, _dist, _parent, _cam)
{
	offset.Set( 187, 187, 187 );
	pos = _pos;
	dist = _dist;
	parent = _parent;
	cam = _cam;

}

void Elbow::Run( Vector3DF rawAcc )
{
	Vector3DF prev = pos;
	acc = rawAcc - OFFSET;
	LPFilter( acc );

	float hyp = acc.Length();

	phi = atan2( acc.y, acc.z );
	theta = asin( acc.x/hyp );

	if( theta > 45 )
		phi = asin( acc.y/hyp );

	vel.x = dist*sin( theta );
	vel.y = dist*cos( phi );
	vel.z = dist*sin( phi );//+ dist*cos(theta);

	pos = parent->pos + vel;

	pos.x = vel.x;

	phi *= (180/PI);
	theta *= (180/PI);
}

void Elbow::Draw()
{
	// Draw the arm
	GameX.SetDrawScale (1.0f);
	GameX.DrawLine3D( ColorX(150,150,150), pos, parent->pos );

	// display the point
	GameX.SetDrawScale (5.0f);
	GameX.DrawImage3D ( &image, pos );

	// display the acceleration vector
	//GameX.DrawLine3D( ColorX(255,0,0), pos, acc+pos );
}